#include <stdlib.h>
#include "base.h"

#define base_new( TYPE, NUM )   return (TYPE*) c_new( NUM, sizeof(TYPE) )

ULI c_size_ULI = sizeof( ULI );
ULI c_size_double = sizeof( double );
ULI c_size_USI = sizeof( USI );
ULI c_size_pointer = sizeof( void* );
ULI c_size_int = sizeof( int );

void* c_new( ULI n, ULI size )
{
  void *p;
  
  p = calloc( n, size );
  if ( !p )
    exit( 1 );
  return p;
}

ULI* c_new_ULI( ULI num )
{
  base_new( ULI, num );
}

double* c_new_double( ULI num )
{
  base_new( double, num );
}

void c_free( void *array )
{
  if ( array != NULL )
  {
    free( array );
    array = NULL;
  }
}

double c_drand( void )
{
  return drand48();
}

ULI c_lrand( void )
{
  return (ULI) lrand48();
}

void c_srand( ULI seed )
{
  srand48( (long int) seed );
}
